#!/usr/bin/php
<?php
/**
 +----------------------------------------------------------
 * [协同版转换成基础物料版]升级总脚本之归档订单
 * 
 * 注意：
 *    a). 升级前请先备份数据库
 *    b). 当捆绑商品货号 与 普通商品货号 相同时，升级转换脚本会自动跳过（需注意）
 +----------------------------------------------------------
 * Author: wangbiao@shopex.cn
 * Time: 2016-04-26 $
 * [Ecos!] (C)2003-2016 Shopex Inc.
 +----------------------------------------------------------
 */
error_reporting(E_ALL ^ E_NOTICE);

$domain     = $argv[1];
$order_id   = $argv[2];
$host_id    = $argv[3];

if (empty($domain) || empty($order_id) || empty($host_id) )
{
    die('No Params');
}

set_time_limit(0);
require_once(dirname(__FILE__) . '/../../lib/init.php');
cachemgr::init(false);

$db     = kernel::database();

/*------------------------------------------------------ */
//-- 客户确认是否已经备份过数据库？
/*------------------------------------------------------ */
printf("You Confirm That You Have Backed Up The Database, Yes/No?");
printf("\n>");

$answer    = read_input();

if(strtolower($answer) != 'yes')
{
    die('Termination Of Execution!');
}



$salesMaterialObj = app::get('material')->model('sales_material');
$salesMaterialExtObj = app::get('material')->model('sales_material_ext');
$salesBasicMaterialObj = app::get('material')->model('sales_basic_material');
$pkgObj = app::get('omepkg')->model('pkg_goods');
$pkgProductObj = app::get('omepkg')->model('pkg_product');



/*------------------------------------------------------ */
//-- Step1.1 [归档]批量更新订单对象表[无规格_商品对应单个商品]
/*------------------------------------------------------ */
echo("\n\nstart step 1.1....\n\n");

$suffix    = 'batch_archive_order_objects';
$total   = 0;
$succ    = 0;
$fail    = 0;

$page     = 0;#开始页
$limit    = 500;#每次执行数量

$result    = batch_archive_order_objects();

ilog('第一步1.1,批量转换归档订单明细已完成, 失败'.$fail.'个', true, $suffix);

/*
 * 订单明细批量转换方法
*
*/
function batch_archive_order_objects()
{
    global $db, $page, $limit, $fail, $suffix;

    #查询订单
    $sql    = "SELECT obj_id, obj_type, goods_id, bn FROM sdb_archive_order_objects WHERE 1=1 GROUP BY bn, obj_type 
               LIMIT ". ($page * $limit) .", " . $limit;
    $orderList    = $db->select($sql);
    
    #没有可执行的货品,则退出.
    if(empty($orderList))
    {
        return false;
    }
    
    #加入事务
    $db->beginTransaction();
    
    foreach ($orderList as $key => $val)
    {
        #获取订单货品bn对应销售物料[需判断销售物料类型sales_material_type_防止捆绑商品货号与普通商品货号相同]
        $sql    = "SELECT sm_id FROM sdb_material_sales_material WHERE sales_material_bn='". $val['bn'] ."' AND is_bind=1";
        $sql    .= ($val['obj_type'] == 'pkg' ? " AND sales_material_type=2" : " AND sales_material_type=1");
        
        $sales_material    = $db->selectrow($sql);
        if(empty($sales_material))
        {
            ilog('obj_type：'. $val['obj_type'] .', 未找到商品BN：'.$val['bn'], false, $suffix.'_notbn');
            
            $fail++;
            continue;
        }
        
        #转换order_objects对象表对应的销售物料信息
        $sql        = "UPDATE `sdb_archive_order_objects` SET goods_id='". $sales_material['sm_id'] ."' 
                       WHERE bn='". $val['bn'] ."' AND obj_type='". $val['obj_type'] ."'";
        $is_save    = $db->exec($sql);
        if(!$is_save)
        {
            $db->rollBack();
            
            echo('Warning: UPDATE sdb_archive_order_objects step 1.1...Error...');
            exit;
        }
        
        #保存更新的货号
        ilog('obj_type：'. $val['obj_type'] .', BN：'.$val['bn'], true, $suffix.'_page');
    }
    
    #提交事务
    $db->commit();
    
    #release
    unset($orderList, $sql, $is_save, $sales_material);
    
    $page++;
    //ilog('Step 1.1,Executed Page '. $page, true, $suffix.'_page');
    
    usleep(500000);#暂停0.5秒
    
    #递归调用
    batch_archive_order_objects();
}




/*------------------------------------------------------ */
//-- Step 1.2: [归档]一个goods型普通objects层对应多个普通order_items
//-- **************************************************
//-- 以objects层上的bn  新建一个***_sys_pkg后缀的促销销售物料
//-- objects层上的quantity购买数量更新为1
//-- **************************************************
/*------------------------------------------------------ */
echo("start step 1.2....\n\n");

$suffix    = 'batch_archive_sys_create_object_bn';
$total   = 0;
$succ    = 0;
$fail    = 0;

$page     = 0;#开始页
$limit    = 500;#每次执行数量

$result    = batch_archive_sys_create_object_bn();

ilog('第一步1.2,批量转换订单明细已完成, 失败'.$fail.'个', true, $suffix);

/*
 * 订单明细批量转换方法
*
*/
function batch_archive_sys_create_object_bn()
{
    global $db, $page, $limit, $fail, $suffix;
    
    #查询订单（注：limit固定500数量，bn、goods_id、obj_type会被更新）
    $sql    = "SELECT b.obj_id, b.bn AS obj_bn, b.name FROM sdb_archive_order_items AS a 
               LEFT JOIN sdb_archive_order_objects AS b ON a.obj_id=b.obj_id 
               WHERE a.item_type='product' GROUP BY a.obj_id HAVING COUNT(a.obj_id)>1 
               LIMIT 0, 500";
    $orderList    = $db->select($sql);
    
    #没有可执行的货品,则退出.
    if(empty($orderList))
    {
        return false;
    }
    
    #加入事务
    $db->beginTransaction();
    
    $obj_ids    = array();
    foreach ($orderList as $key => $val)
    {
        //系统自动生成pkg促销销售物料
        $sales_material    = archive_sys_create_pkg_sales_material($val);
        if(!$sales_material)
        {
            #事务回滚
            $db->rollBack();
            
            echo('Warning: create sdb_material_pkg_sales_material...Error...');
            exit;
        }
        
        //更新order_objects层上bn、goods_id、quantity、obj_type
        $update_sql    = "UPDATE `sdb_archive_order_objects` 
                          SET goods_id=". $sales_material['sm_id'] .", bn='". $sales_material['sales_material_bn'] ."', quantity=1, obj_type='pkg' 
                          WHERE obj_id=". $val['obj_id'];
        $result    = $db->exec($update_sql);
        if(!$result)
        {
            $db->rollBack();
            
            echo('Warning: UPDATE sdb_archive_order_objects step 5.3...Error...');
            exit;
        }
        
        //obj_id
        $obj_ids[]    = $val['obj_id'];
    }
    
    #[统一]更新order_items层上item_type为捆绑类型
    if($obj_ids)
    {
        $update_sql    = "UPDATE `sdb_archive_order_items` SET item_type='pkg' WHERE obj_id IN(". implode(',', $obj_ids) .")";
        $result    = $db->exec($update_sql);
        if(!$result)
        {
            $db->rollBack();
            
            echo('Warning: UPDATE sdb_archive_order_items step 5.3...Error...');
            exit;
        }
    }
    
    #提交事务
    $db->commit();
    
    #release
    unset($orderList, $sql, $sales_material, $result, $update_sql, $obj_ids);
    
    $page++;
    //ilog('Step 1.2,Executed Page '. $page, true, $suffix.'_page');
    
    usleep(500000);#暂停0.5秒
    
    #递归调用
    batch_archive_sys_create_object_bn();
}




/*------------------------------------------------------ */
//-- Step 1.3.[归档]批量更新订单对象表
//-- 有规格_商品对应多个货品时
//-- order_objects层上obj_bn没有对应销售物料
/*------------------------------------------------------ */
echo("start step 1.3...\n\n");

$suffix    = 'batch_archive_orders_objects_by_goods';
$total   = 0;
$succ    = 0;
$fail    = 0;
$page    = 0;#开始页

$result    = batch_archive_orders_objects_by_goods();

ilog('第一步1.3,批量更新订单对象表已完成, 失败'.$fail.'个', true, $suffix);

/*
 * 订单明细批量转换方法
*
*/
function batch_archive_orders_objects_by_goods()
{
    global $db, $fail, $suffix, $page;

    #查询订单（注：limit固定500数量，bn、goods_id会被更新）
    $sql    = "SELECT a.obj_id, c.bn AS item_bn FROM sdb_archive_order_objects AS a 
               LEFT JOIN sdb_archive_order_items AS c ON a.obj_id=c.obj_id 
               WHERE a.obj_type='goods' AND a.bn in(SELECT bn FROM sdb_ome_goods WHERE spec_desc != '') AND c.bn!='' 
               GROUP BY c.obj_id LIMIT 0, 500";
    $orderList    = $db->select($sql);
    
    #没有可执行的货品,则退出.
    if(empty($orderList))
    {
        return false;
    }
    
    #加入事务
    $db->beginTransaction();
    
    foreach ($orderList as $key => $val)
    {
        #根据item_bn查找对应的销售物料
        $sql    = "SELECT sm_id, sales_material_bn FROM sdb_material_sales_material WHERE sales_material_bn='". $val['item_bn'] ."'";
        $sales_material    = $db->selectrow($sql);
        
        if($sales_material)
        {
            #更新objects层数据
            $update_sql    = "UPDATE `sdb_archive_order_objects` SET goods_id=". $sales_material['sm_id'] .", bn='". $sales_material['sales_material_bn'] ."' 
                              WHERE obj_id=". $val['obj_id'];
            $result    = $db->exec($update_sql);
            if(!$result)
            {
                $db->rollBack();
                
                echo('Warning: UPDATE sdb_archive_order_objects step 1.3...Error...');
                exit;
            }
        }
        else
        {
            //系统自动生成普通销售物料
            $sales_material    = archive_sys_create_normal_sales_material($val);
            if(!$sales_material)
            {
                #事务回滚
                $db->rollBack();
                
                echo('Warning: create sdb_material_normal_sales_material...Error...');
                exit;
            }
            
            //更新order_objects层上bn、goods_id
            $update_sql    = "UPDATE `sdb_archive_order_objects` SET goods_id=". $sales_material['sm_id'] .", bn='". $sales_material['sales_material_bn'] ."' 
                              WHERE obj_id=". $val['obj_id'];
            $result    = $db->exec($update_sql);
            if(!$result)
            {
                $db->rollBack();
                
                echo('Warning: UPDATE sdb_archive_order_objects step 1.3...Error...');
                exit;
            }
            
            ilog('第一步1.3,销售物料bn: '. $val['bn'] .' 不存在, 系统自动新建销售物料号:'. $sales_material['sales_material_bn'] .'并匹配', false, $suffix.'_create');
        }
    }
    
    #提交事务
    $db->commit();
    
    #release
    unset($orderList, $sql, $sales_material, $result, $update_sql);
    
    $page++;
    //ilog('Step 1.3,Executed Page '. $page, true, $suffix.'_page');
    
    usleep(500000);#暂停0.5秒
    
    #递归调用
    batch_archive_orders_objects_by_goods();
}




#脚本执行完成
echo("...Upgrade completed...\n\n");



/**
 * 日志
 */
function ilog($str, $flag = false, $suffix='')
{
    global $domain;
    
    $suffix    = ($suffix ? $suffix . '_' : '');#文件后缀名
    
    $filename = dirname(__FILE__) . '/../logs/upgrade4.0_'. $suffix .'fail_' . date('Y-m-d') . '.log';
    
    if($flag)
    {
        $filename = dirname(__FILE__) . '/../logs/upgrade4.0_'. $suffix .'success_' . date('Y-m-d') . '.log';
    }
    
    $fp = fopen($filename, 'a');
    fwrite($fp, date("m-d H:i") . "\t" . $domain . "\t" . $str . "\n");
    fclose($fp);
}

/**
 * 执行时输入的参数
 */ 
function read_input()
{
    $fp = fopen("/dev/stdin", "r");
    $input = trim(fgets($fp, 255));
    fclose($fp);
    return $input;
}


/**
 * 系统自动新建PKG促销销售物料
 * @param $param  订单对象信息
 *
 * return Boolean
 */
function archive_sys_create_pkg_sales_material($param)
{
    global $db, $salesMaterialObj, $salesMaterialExtObj;
    
    //系统生成的销售物料编码
    $param['obj_bn']    = 'sys_pkg_'. $param['obj_id'];#使用obj_id为bn,防止商品货号是空_或者是_中文
    
    //判断促销物料编号是否已经被占用
    $sales_material    = $salesMaterialObj->dump(array('sales_material_bn'=>$param['obj_bn'], 'sales_material_type'=>2), 'sm_id, sales_material_bn');
    if($sales_material)
    {
        return $sales_material;
    }
    
    //新建促销销售物料
    $sales_material_bn_crc32    = sprintf('%u',crc32($param['obj_bn']));
    $param['name']    = str_replace("'", "", $param['name']);#替换单引号
    $new_pkg_data = array(
            'shop_id' => '_ALL_',
            'sales_material_name' => $param['name'],
            'sales_material_bn' => $param['obj_bn'],
            'sales_material_bn_crc32' => $sales_material_bn_crc32,
            'sales_material_type' => 2,
            'is_bind' => 1,
            'create_time' => time(),
    );
    $is_save = $salesMaterialObj->save($new_pkg_data);
    if(!$is_save)
    {
        return false;
    }
    
    //新建促销销售的扩展信息
    $new_pkg_ext_data = array(
            'sm_id' => $new_pkg_data['sm_id'],
            'cost' => 0.00,
            'retail_price' => 0.00,
            'weight' => 0.00,
            'unit' => '',
    );
    $is_save    = $salesMaterialExtObj->insert($new_pkg_ext_data);
    if(!$is_save)
    {
        return false;
    }
    
    //销售物料基础物料关联数据结构
    $sql    = "SELECT product_id, nums FROM sdb_archive_order_items WHERE obj_id=". $param['obj_id'];
    $item_list    = $db->select($sql);
    if($item_list)
    {
        //if(count($item_list) > 1)
        //{
            $pkg_product_list     = array();
            $pkg_product_count    = 0;
            foreach ($item_list as $key => $val)
            {
                $pkg_product_list[$val['product_id']]    = array('pkgnum'=>$val['nums'], 'percent'=>0);
                
                $pkg_product_count += $val['nums'];
            }
        //}
        
        $percent    = 100;
        $rate       = 100;#默认
        $loop       = 1;
        foreach ($item_list as $key => $val)
        {
            $pkg_product_id    = $val['product_id'];
            
            #计算贡献占比
            if($pkg_product_list)
            {
                if($loop == count($item_list))
                {
                    $pkg_product_list[$pkg_product_id]['percent']    = $percent;
                }
                else
                {
                    $diff_num    = round(($pkg_product_list[$pkg_product_id]['pkgnum'] / $pkg_product_count), 2);
                    $diff_num    = intval($diff_num * 10) * 10;
                    $pkg_product_list[$pkg_product_id]['percent']    = $diff_num;
                    
                    $percent    = $percent - $diff_num;
                    $percent    = ($percent < 0 ? 0 : $percent);
                }
                $loop++;
                
                $rate    = intval($pkg_product_list[$pkg_product_id]['percent']);#取整10的倍数
            }
            
            #拼接数据
            $insert_list[$pkg_product_id]    = "(". $new_pkg_data['sm_id'] .",". $pkg_product_id .",". $pkg_product_list[$pkg_product_id]['pkgnum'] .",". $rate .")";
        }
        
        #插入
        $insert_sql    = "INSERT INTO `sdb_material_sales_basic_material` (`sm_id`,`bm_id`,`number`,`rate`) VALUES";
        $insert_sql    .= implode(',', $insert_list);
        $result        = $db->exec($insert_sql);
        if(!$result)
        {
            return false;
        }
    }
    
    #release
    unset($sql, $insert_sql, $sales_material, $sales_material_bn_crc32, $new_pkg_ext_data, $insert_list, $result, $pkg_product_id, $loop, $rate, $is_save);
    
    return array('sm_id'=>$new_pkg_data['sm_id'], 'sales_material_bn'=>$param['obj_bn']);
}


/**
 * 系统自动新建普通销售物料
 * @param $param  订单对象信息
 *
 * return Boolean
 */
function archive_sys_create_normal_sales_material($param)
{
    global $db, $salesMaterialObj, $salesMaterialExtObj;
    
    //系统生成的销售物料编码
    $param['obj_bn']    = 'sys_normal_'. $param['obj_id'];#使用obj_id为bn,防止商品货号是空_或者是_中文
    
    //单独查询order_objects订单对象表上的name值
    $sql         = "SELECT name FROM sdb_archive_order_objects WHERE obj_id=". $param['obj_id'];
    $obj_info    = $db->selectrow($sql);
    $param['name']    = $obj_info['name'];
    
    //判断普通物料编号是否已经被占用
    $sales_material    = $salesMaterialObj->dump(array('sales_material_bn'=>$param['obj_bn'], 'sales_material_type'=>1), 'sm_id, sales_material_bn');
    if($sales_material)
    {
        return $sales_material;
    }
    
    //新建普通销售物料
    $sales_material_bn_crc32    = sprintf('%u',crc32($param['obj_bn']));
    $param['name']    = str_replace("'", "", $param['name']);#替换单引号
    $new_pkg_data = array(
            'shop_id' => '_ALL_',
            'sales_material_name' => $param['name'],
            'sales_material_bn' => $param['obj_bn'],
            'sales_material_bn_crc32' => $sales_material_bn_crc32,
            'sales_material_type' => 1,
            'is_bind' => 1,
            'create_time' => time(),
    );
    $is_save = $salesMaterialObj->save($new_pkg_data);
    if(!$is_save)
    {
        return false;
    }
    
    //新建促销销售的扩展信息
    $new_pkg_ext_data = array(
            'sm_id' => $new_pkg_data['sm_id'],
            'cost' => 0.00,
            'retail_price' => 0.00,
            'weight' => 0.00,
            'unit' => '',
    );
    $is_save    = $salesMaterialExtObj->insert($new_pkg_ext_data);
    if(!$is_save)
    {
        return false;
    }
    
    //销售物料基础物料关联数据结构
    $sql    = "SELECT product_id, nums FROM sdb_archive_order_items WHERE obj_id=". $param['obj_id'];
    $item_list    = $db->select($sql);
    if($item_list)
    {
        //if(count($item_list) > 1)
        //{
            $pkg_product_list     = array();
            $pkg_product_count    = 0;
            foreach ($item_list as $key => $val)
            {
                $pkg_product_list[$val['product_id']]    = array('pkgnum'=>$val['nums'], 'percent'=>0);
                
                $pkg_product_count += $val['nums'];
            }
        //}
        
        $percent    = 100;
        $rate       = 100;#默认
        $loop       = 1;
        foreach ($item_list as $key => $val)
        {
            $pkg_product_id    = $val['product_id'];
            
            #计算贡献占比
            if($pkg_product_list)
            {
                if($loop == count($item_list))
                {
                    $pkg_product_list[$pkg_product_id]['percent']    = $percent;
                }
                else
                {
                    $diff_num    = round(($pkg_product_list[$pkg_product_id]['pkgnum'] / $pkg_product_count), 2);
                    $diff_num    = intval($diff_num * 10) * 10;
                    $pkg_product_list[$pkg_product_id]['percent']    = $diff_num;
                    
                    $percent    = $percent - $diff_num;
                    $percent    = ($percent < 0 ? 0 : $percent);
                }
                $loop++;
                
                $rate    = intval($pkg_product_list[$pkg_product_id]['percent']);#取整10的倍数
            }
            
            #拼接数据
            $insert_list[$pkg_product_id]    = "(". $new_pkg_data['sm_id'] .",". $pkg_product_id .",". $pkg_product_list[$pkg_product_id]['pkgnum'] .",". $rate .")";
        }
        
        #插入
        $insert_sql    = "INSERT INTO `sdb_material_sales_basic_material` (`sm_id`,`bm_id`,`number`,`rate`) VALUES";
        $insert_sql    .= implode(',', $insert_list);
        $result        = $db->exec($insert_sql);
        if(!$result)
        {
            return false;
        }
    }
    
    #release
    unset($sql, $insert_sql, $sales_material, $sales_material_bn_crc32, $new_pkg_ext_data, $insert_list, $result, $pkg_product_id, $loop, $rate, $is_save);
    
    return array('sm_id'=>$new_pkg_data['sm_id'], 'sales_material_bn'=>$param['obj_bn']);
}
